//
// File:    hm_HMake.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_hmake:
//      Erzeugung von h-Dateien

#ifndef HDR_hm_HMake
#define HDR_hm_HMake

// C++

#ifndef LIB_list
#include <list>
#define LIB_list
#endif

// HMake

#ifndef HDR_hm_Layout
#include "hm_Layout.h"
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_hmake
// -----------------------------------------------------------------------------------------

using namespace std;

class hm_attribute_protocol;
class hm_component;

class hm_hmake
{
        const hm_layout d_Layout;

    private:

    // Nicht implementiert

        hm_hmake (const hm_hmake&);
        hm_hmake& operator= (const hm_hmake&);

    // Nicht-Konstante

        bool MakeComponent (const list<hm_component>& Components, hm_component& Component,
            const list<hm_attribute_protocol *>& Attributes);
        // Return: Ok?

    public:

    // Konstruktoren

        hm_hmake (const hm_layout& Layout);
        ~hm_hmake();

    // Nicht-Konstante

        bool Make (list<hm_component>& Components,
            const list<hm_attribute_protocol *>& Attributes);
        // Return: Ok?
};

#endif
